<?php
namespace Folha\Repositories;

use \Folha\Entities\FpaItemlotelanc as Itemlotelanc;

use \Geral\Util\Ambiente;

class FpaItemlotelanc extends \Doctrine\ORM\EntityRepository
{
    /**
     * @param Itemlotelanc $info
     * @throws \Exception
     */
    public static function insereItem(Itemlotelanc $info)
    {
        $params = array('P_NRITLOTELANC'        => $info->getNritlotelanc(),
                        'P_NRLOTELANCEVENTO'    => $info->getNrlotelancevento(),
                        'P_NRVINCULOM'          => $info->getNrvinculom(),
                        'P_NREVENTOM'           => $info->getNreventom(),
                        'P_VRREFFOLHALOTE'      => $info->getVrreffolhalote(),
                        'P_VREVENTOLOTE'        => $info->getVreventolote(),
                        'P_IDATIVO'             => $info->getIdativo(),
                        'P_NRORGINCLUSAO'       => $info->getNrorginclusao(),
                        'P_DTINCLUSAO'          => $info->getDtinclusao()->format('d/m/Y'),
                        'P_CDOPERINCLUSAO'      => $info->getCdoperinclusao(),
                        'P_NRORGULTATU'         => $info->getNrorgultatu(),
                        'P_DTULTATU'            => $info->getDtultatu()->format('d/m/Y'),
                        'P_CDOPERULTATU'        => $info->getCdoperultatu(),
                        ':P_NRORG'              => $info->getNrorg());

        $sql = <<<SQL
INSERT INTO FPA_ITEMLOTELANC
    (NRITLOTELANC,
    NRLOTELANCEVENTO,
    NRVINCULOM,
    NREVENTOM,
    VRREFFOLHALOTE,
    VREVENTOLOTE,
    IDATIVO,
    NRORGINCLUSAO,
    DTINCLUSAO,
    CDOPERINCLUSAO,
    NRORGULTATU,
    DTULTATU,
    CDOPERULTATU,
    NRORG)
VALUES
    (:P_NRITLOTELANC,
    :P_NRLOTELANCEVENTO,
    :P_NRVINCULOM,
    :P_NREVENTOM,
    :P_VRREFFOLHALOTE,
    :P_VREVENTOLOTE,
    :P_IDATIVO,
    :P_NRORGINCLUSAO,
    :P_DTINCLUSAO,
    :P_CDOPERINCLUSAO,
    :P_NRORGULTATU,
    :P_DTULTATU,
    :P_CDOPERULTATU,
    :P_NRORG)
SQL;

        try {
            \Setforms2\Shared\Connection::getInstance()->execute($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }
}