CREATE OR REPLACE FUNCTION ARQUIVO_GIM_RN_13(
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_CONTADOR     IN NUMBER) RETURN VARCHAR
AS
   V_DADOS               VARCHAR2(4000);
   V_DADOS_17            VARCHAR2(4000);
   V_CONTADOR            NUMBER;
   V_VRTOTAIMPOS         NUMBER;
   V_VRIMPSUBST          NUMBER;
   V_VRTOTAIMPSUBST      NUMBER;
   V_VRIMPOSTONF_TRS     NUMBER;
   V_VRDIFALIQU          NUMBER;

BEGIN
   V_CONTADOR := P_CONTADOR;
   V_VRTOTAIMPSUBST := 0;

   SELECT SUM(VRTOTAIMPOS)
     INTO V_VRTOTAIMPOS
     FROM MAPAAPURAC M
    WHERE M.CDEMPRESA = P_CDEMPRESA
      AND M.CDINSCESTA = P_CDINSCESTA
      AND M.DTINIPERIODO = P_DTINICIAL
      AND M.DTFIMPERIODO = P_DTFINAL
      AND M.CDIMPOSTO = P_CDIMPOSTO;

   FOR C_IMP IN (SELECT CDIMPOSTRIB
                   FROM IMPOSTO
                  WHERE CDIMPOSTONFE = P_CDIMPOSTO) LOOP

       SELECT SUM(VALOR_IMPOSTO_NF(I.CDFILIAL, I.NRLANCTONF, C_IMP.CDIMPOSTRIB, 'I'))
         INTO V_VRIMPSUBST
         FROM IMPOSTONF I, MAPAAPURAC M
        WHERE M.CDEMPRESA = P_CDEMPRESA
          AND M.CDINSCESTA = P_CDINSCESTA
          AND M.DTINIPERIODO = P_DTINICIAL
          AND M.DTFIMPERIODO = P_DTFINAL
          AND M.CDIMPOSTO = P_CDIMPOSTO
          AND I.CDFISCALNF = '1'
          AND I.IDIMPOSTONF <> '3'
          AND I.NRSEQUMAPAPU = M.NRSEQUMAPAPU;

       V_VRTOTAIMPSUBST := V_VRTOTAIMPSUBST + V_VRIMPSUBST;

   END LOOP;

   V_DADOS := LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_VRTOTAIMPOS,'0'),2), '999999999990.00')), '.', ''), 14, '0')||
              LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_VRIMPSUBST,'0'),2), '999999999990.00')), '.', ''), 14, '0');


   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (RPAD('13',10,'0'), V_DADOS, P_NRSEQARQMAG);

   /* ICMS do Perodo (Substituto pelas Sadas  Prestaes de Servio / Mercadorias) */
   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (RPAD('14',10,'0'), LPAD('0',28,'0'), P_NRSEQARQMAG);

   /* ICMS do Perodo (Substituto pelas Entradas) */
   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (RPAD('15',10,'0'), LPAD('0',28,'0'), P_NRSEQARQMAG);

   /* ICMS do Perodo (Ativo Permanente: Crdito Normal/Consumo) */
   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (RPAD('16',10,'0'), LPAD('0',28,'0'), P_NRSEQARQMAG);

   /* ICMS do Perodo (Servio de Transporte / Diferena de Alquotas) */
   SELECT NVL(SUM(VRIMPOSTONF),0), NVL(SUM(VRDIFALIQU),0)
     INTO V_VRIMPOSTONF_TRS, V_VRDIFALIQU
     FROM MAPAAPURAC M, MAPARECUP R,
        (SELECT M.NRSEQUMAPAPU, SUM(NVL(I.VRIMPOSTONF,0)) AS VRIMPOSTONF
           FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO P, MAPAAPURAC M
          WHERE M.CDEMPRESA = P_CDEMPRESA
            AND M.CDIMPOSTO = P_CDIMPOSTO
            AND M.CDINSCESTA = P_CDINSCESTA
            AND M.DTINIPERIODO = P_DTINICIAL
            AND M.DTFIMPERIODO = P_DTFINAL
            AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
            AND I.CDIMPOSTO = P.CDIMPOSTO
            AND P.CDIMPOSTONFE = P_CDIMPOSTO
            AND I.CDFISCALNF = '1'
            AND N.CDFILIAL = I.CDFILIAL
            AND N.NRLANCTONF = I.NRLANCTONF
            AND N.CDMODDOCFISC = '07'
          GROUP BY M.NRSEQUMAPAPU) I
    WHERE M.CDEMPRESA = P_CDEMPRESA
      AND M.CDIMPOSTO = P_CDIMPOSTO
      AND M.CDINSCESTA = P_CDINSCESTA
      AND M.DTINIPERIODO = P_DTINICIAL
      AND M.DTFIMPERIODO = P_DTFINAL
      AND M.NRSEQUMAPAPU = R.NRSEQUMAPAPU
      AND R.NRSEQUMAPAPU = I.NRSEQUMAPAPU(+);

   V_DADOS_17 := LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_VRIMPOSTONF_TRS,'0'),2), '999999999990.00')), '.', ''), 14, '0')||
                 LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_VRDIFALIQU,'0'),2), '999999999990.00')), '.', ''), 14, '0');

   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (RPAD('17',10,'0'), V_DADOS_17, P_NRSEQARQMAG);

   /* ICMS do Perodo (Diferimento: Importao / Regime Especial) */
   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (RPAD('18',10,'0'), LPAD('0',28,'0'), P_NRSEQARQMAG);

   /* ICMS do Perodo (FECOP  Normal / Substituto) */
   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (RPAD('19',10,'0'), LPAD('0',28,'0'), P_NRSEQARQMAG);

   RETURN(LPAD(TO_CHAR(V_CONTADOR), 10, '0'));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_GIM_RN_13','5.30.000'); END;
/

